//+------------------------------------------------------------------+
//|                                                       gbemi1.mq4 |
//|                                             Copyright 2013, Igor |
//|                                            buildorbust@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Igor"
#property link      "buildorbust@yahoo.com"
// Modified by Alain Verleyen 2013.04.21
// Replace all indictors with adx-buy-sell - mtf
int magic=543534;
extern double mLot = 0.1;
extern int slippage = 3;
//extern double stopLoss = 100;
//extern double takeProfit = 100;
extern bool closeTrades = false;
extern bool Trade = true;
extern double maxSpread = 5.5;
extern string c5 = "____ Adx buy-sell ____";
extern int ADXcrossesPeriod = 14;
extern int shift            = 1;
extern string c1 = "____  gains some certain pips ____";
extern bool gainOn = false;
extern double somePips = 20;
extern string c3 = "____ breakeven ____";
extern bool breakOn = false;
extern double breakeven = 30;
extern string c2 = "____ Trailing ____";
extern bool trailOn = false;
extern double trailingStop = 15.0;
extern double trailingStep = 10.0;
extern string c4 = "____ trading times or allow open ____";
extern string fromTime = "0:00";
extern string toTime = "23:59";

int pip, lotdigits;
double minLot;
double maxLot;
bool exit=false;
datetime lastTime=0;
double lockProfit=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   int x,y;
//----
   minLot = MarketInfo(Symbol(), MODE_MINLOT);
   maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
//----
   if(Digits==3 || Digits==5)
   {
      pip=10;
   }   
   else
   {
      pip=1; 
   }   
   while(true)
   {
      x=minLot*100000;
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=5;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=4;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=3;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=2;      
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=1;   
         break;
      }
      break;   
   }   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
    double val,val2,val3,val4;
    int bo,pbo,so,pso,i;
    double tp,sl,open,lot;
    bool buySignal=false, sellSignal=false;
    
    datetime time = TimeCurrent();
    double stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
    double spread = MarketInfo(Symbol(),MODE_SPREAD);
    if(!Trade)
      return;

    //val  = iCustom(NULL, 0, "adx-buy-sell - mtf", ADXcrossesPeriod, 0, 1);
    //val2 = iCustom(NULL, 0, "adx-buy-sell - mtf", ADXcrossesPeriod, 1, 1);
    double b4plusdi   = iADX(NULL,0, ADXcrossesPeriod, PRICE_CLOSE, MODE_PLUSDI, shift+1);
    double nowplusdi  = iADX(NULL,0, ADXcrossesPeriod, PRICE_CLOSE, MODE_PLUSDI, shift);
    double b4minusdi  = iADX(NULL,0, ADXcrossesPeriod, PRICE_CLOSE, MODE_MINUSDI,shift+1);
    double nowminusdi = iADX(NULL,0, ADXcrossesPeriod, PRICE_CLOSE, MODE_MINUSDI,shift);  

    if(b4plusdi < b4minusdi && nowplusdi > nowminusdi)
      buySignal = true;

    if(b4plusdi > b4minusdi && nowplusdi < nowminusdi)   
      sellSignal = true;
      
   
   if(exit || closeTrades)
   {
      if(!close_all(true,true,true,true))
            return;
      exit=false;
   }
   datetime time2 = StrToTime(fromTime);
   datetime time3 = StrToTime(toTime);
//----

   total_open(bo,pbo,so,pso);
   if(bo+pbo+so+pso==0)
   {     
         lockProfit=0;
         if(time < time2 || time > time3 || !Trade || spread*Point > maxSpread*Point*pip)
            return;   
         if(lastTime!=Time[0])
         {
            if(buySignal)//buy
            {
               if(OrderSend(Symbol(),OP_BUY,NormalizeDouble(mLot,lotdigits),NormalizeDouble(Ask,Digits),slippage,0,0,"",magic,0,Blue)!=-1)
               {
                  lastTime=Time[0];
               }
            }
            else if(sellSignal)//sell
            {
               if(OrderSend(Symbol(),OP_SELL,NormalizeDouble(mLot,lotdigits),NormalizeDouble(Bid,Digits),slippage,0,0,"",magic,0,Red)!=-1)
               {
                  lastTime=Time[0];     
               }
            }
         }
   }
   else
   {
      if(lastTime!=Time[0])
      {
         if(bo+pbo>0)
         {
            if(sellSignal)
            {
               exit = true;
              // lastTime=Time[0];
               return;
            }   
         }
         if(so+pso>0)
         {
            if(buySignal)
            {
               exit=true;
               //lastTime=Time[0];
               return;
            }
         }
      }
      if(gainOn && Trade && spread*Point < maxSpread*Point*pip)
      {
         val = profitPip();
        // Comment(val+" "+lockProfit+" "+somePips);
         if(val  > somePips)
         {
            if(bo+pbo>0)
            {
               if(OrderSend(Symbol(),OP_BUY,NormalizeDouble(mLot,lotdigits),NormalizeDouble(Ask,Digits),slippage,0,0,"",magic,0,Blue)!=-1)
               {
                 // lockProfit=val;        
                  lastTime=Time[0];
               }
            }
            else if(so+pso>0)
            {
               if(OrderSend(Symbol(),OP_SELL,NormalizeDouble(mLot,lotdigits),NormalizeDouble(Bid,Digits),slippage,0,0,"",magic,0,Red)!=-1)
               {
                 // lockProfit=val; 
                  lastTime=Time[0];     
               }
            }
         }
      }
      //----------
      RefreshRates();
      for(i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS))
         {
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
            {  
               sl = OrderStopLoss();
               tp = OrderTakeProfit();
               if(OrderType() == OP_BUY)
               {
                  if(breakOn)
                  {
                     if(Bid > OrderOpenPrice() + breakeven*Point*pip)
                     {
                        val = OrderOpenPrice();
                        if(val > sl || sl == 0)
                        {
                           sl = val;
                        }   
                     }
                  }   
                  if(trailOn)
                  {
                     val = NormalizeDouble(Bid - trailingStep*Point*pip,Digits);
                     if(((val > sl && (val-sl > trailingStep*Point*pip)) || sl == 0) && Bid - trailingStop*Point*pip > OrderOpenPrice() )
                        sl = val;
                  }
                  if(Bid - sl < stopLevel*Point)
                     sl=OrderStopLoss();   
               }
               if(OrderType() == OP_SELL)
               {
                  if(breakOn)
                  {
                     if(Ask < OrderOpenPrice() - breakeven*Point*pip)
                     {
                        val = OrderOpenPrice();
                        if(val < sl || sl == 0)
                        {
                           sl = val;
                        }   
                     }
                  }   
                  if(trailOn)
                  {
                     val = NormalizeDouble(Ask + trailingStep*Point*pip,Digits);
                     if(((val < sl && (sl - val > trailingStep*Point*pip)) || sl == 0) && Ask + trailingStop*Point*pip < OrderOpenPrice())
                        sl = val;
                  }
                  if(sl - Ask < stopLevel*Point)
                     sl=OrderStopLoss();    
               } 
               sl = NormalizeDouble(sl,Digits);
               tp = NormalizeDouble(tp,Digits);
               if(!cd(sl,OrderStopLoss(),Digits) || !cd(tp,OrderTakeProfit(),Digits))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0);
               }       
            }
         }
      }//for   
      //---------
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+

double profitPip()
{
   double profit=0;
   int ord_type;
   int total = OrdersTotal();
   datetime time=0;
   for(int i=total-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderSymbol() == Symbol())
      {
         ord_type=OrderType();
         if(ord_type==OP_BUY)
         {
            if(OrderOpenTime() > time)
            {
               profit = (Bid - OrderOpenPrice())/Point/pip;
               time = OrderOpenTime();
            }   
         }   
         else if(ord_type==OP_SELL)
         {
            if(OrderOpenTime() > time)
            {
               profit = (OrderOpenPrice()-Ask)/Point/pip;
               time = OrderOpenTime();
            }   
         }   
      }
   }
   return(profit);
}
bool close_all(bool closebuy, bool closesell, bool closepbuy,bool closepsell)
{
   int i,ord_type;
   int total,cnt;
   int max_try;
   
   max_try=0;
   cnt=-1;
  
   while(cnt!=0 && max_try<10)
   {
      total = OrdersTotal();
      cnt=0;
      for (i = total-1; i>=0; i--)
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if(OrderSymbol() == Symbol())
        {
           ord_type=OrderType();
           if (ord_type==OP_BUY && closebuy) 
           {
               OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), slippage,Blue);
               cnt++;
           }
           else if (ord_type==OP_SELL && closesell) 
           {
              OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), slippage,Red);
              cnt++;
           }
           else if((ord_type==OP_BUYSTOP || ord_type==OP_BUYLIMIT) && closepbuy)
           { 
               OrderDelete(OrderTicket(),Aqua);
               cnt++;
           }
           else if((ord_type==OP_SELLSTOP || ord_type==OP_SELLLIMIT) && closepsell)
           { 
               OrderDelete(OrderTicket(),Orchid);
               cnt++;
           }
        }   
      }
      Sleep(2000);
      max_try++;
   }
   if(cnt==0)
     return(true);
   else
      return(false);  
}

double total_open(int &bo1,int &bo2, int &so1, int &so2)
{
   int i, total,ord_type;
   total = OrdersTotal();
   bo1=0;bo2=0;so1=0;so2=0;
   for(i=total-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderSymbol() == Symbol())
      {
         ord_type=OrderType();
         if(ord_type==OP_BUY)
            bo1++;
         else if(ord_type==OP_BUYSTOP || ord_type==OP_BUYLIMIT)
            bo2++;   
         else if(ord_type==OP_SELL)
            so1++;
         else if(ord_type==OP_SELLSTOP || ord_type==OP_SELLLIMIT)
            so2++;   
      }
   }
}

bool cd(double number1,double number2,int prec)
{
   if(NormalizeDouble(number1-number2,prec)==0)
      return(true);
   else 
      return(false);
}

